const system = require("../../../system");
var settings = require("../../../../config/settings");
var APIBase = require("../../api.base");

class TradetransferAPI extends APIBase {
  constructor() {
    super();
    this.execlient = system.getObject("util.execClient");
    this.channelApiUrl = settings.channelApiUrl();
    this.appInfo = {
      aliyuntmtransfer: { appkey: "201911131657", secret: "eeb18393aade40149287b024d8ba0850" }
    };
  }

  async getToken() {
    var self = this;
    var reqTokenUrl = this.channelApiUrl + "/auth/accessAuth/getToken";
    var reqParam = self.appInfo["aliyuntmtransfer"];
    if (!reqParam.appkey || !reqParam.secret) {
      return system.getResult(null, "reqType类型有误，请求失败");
    }
    var rtn = await this.execlient.execPost(reqParam, reqTokenUrl);
    if (!rtn.stdout) {
      return system.getResult(null, "获取token失败");
    }
    var tokenResult = JSON.parse(rtn.stdout);
    if (tokenResult.status == 0) {
      tokenResult.data.secret = reqParam.secret;
    }
    return tokenResult;
  }

  //订单创建
  async acceptOrder(p,obj) {
    var sobj = {
      "actionProcess": "aliyuntmtransfer",
      "actionType": "aliclient",
      "sign": "2FviZ9PGws8Pt1fBhq0t90mjUvI",
      "isUser": "yes",
      "actionBody": obj
    }
    var tokenInfo = await this.getToken();
    var url = this.channelApiUrl + "/api/action/tradetransfer/createtransfer";
    var rtn = await this.execlient.execPostTK(sobj, url, tokenInfo.data.token);
    //var rtn = await this.execlient.execPostTK(sobj, url,"token");
    return rtn;
  }
  //订单查询
  async queryOrderState(p,obj) {
    var sobj = {
      "actionProcess": "aliyuntmtransfer",
      "actionType": "aliclient",
      "sign": "2FviZ9PGws8Pt1fBhq0t90mjUvI",
      "actionBody": obj
    }
    var tokenInfo = await this.getToken();
    var url = this.channelApiUrl + "/api/action/tradetransfer/ordersel";
    var rtn = await this.execlient.execPostTK(sobj, url, tokenInfo.data.token);
    // var rtn = await this.execlient.execPostTK(sobj, url,"token");
    return rtn;
  }

  //订单关闭
  async closeOrder(p,obj) {
    var sobj = {
      "actionProcess": "aliyuntmtransfer",
      "actionType": "aliclient",
      "sign": "2FviZ9PGws8Pt1fBhq0t90mjUvI",
      "actionBody": obj
    }
    var tokenInfo = await this.getToken();
    var url = this.channelApiUrl + "/api/transfer/tradeApi/orderclose";
    var rtn = await this.execlient.execPostTK(sobj, url, tokenInfo.data.token);
    // var rtn = await this.execlient.execPostTK(sobj, url,"token");
    return rtn;
  }

}
module.exports = TradetransferAPI;
